//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGDOMAINCONSTRAINT_H
#define KPGDOMAINCONSTRAINT_H

#include "kpgobject.h"

class KPGDomainConstraintsFolder;


/**
  * Domain check constraint
  *
  * @author Lumir Vanek
  */
class KPGDomainConstraint : public KPGObject
{
public:
    KPGDomainConstraint(KPGDomainConstraintsFolder *, const QString, pqxx::oid);
    KPGDomainConstraint(KPGDomainConstraintsFolder *, KPGDomainConstraint *, const QString, pqxx::oid);
    ~KPGDomainConstraint();
    
    virtual eNodeType type() const { return nodeDomainConstr; }
    
    // Get SQL object type 
  	virtual const char * getObjectType() const { return "DOMAIN CONSTRAINT"; }
    
	void setProperties(const pqxx::result::tuple &, const KPGConnection *pConnection);
        
    // Refresh item, ald also childs objects
	void refresh() throw(const KPGSqlException &) { return; }
 
 	/*
	 * Functions for accessing properties
	 */
 	const QString & expression() const { return m_strExpression; }
	const QString & namespaceName() const { return  m_strNspName; }
	
protected:
	
	/*
	 * Properties
	 */
	QString m_strExpression;
	QString m_strNspName;
};

#endif
