//
// C++ Interface: kpggroupsfolder
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGGROUPSFOLDER_H
#define KPGGROUPSFOLDER_H

#include "kpgitemsfolder.h"

class KPGServer;
class KPGConnection;


/**
  * Folder that holds groups
  *
  * @author Lumir Vanek
  */
class KPGGroupsFolder : public KPGItemsFolder
{
public:
    KPGGroupsFolder(KPGServer *);
    ~KPGGroupsFolder();

	virtual eNodeType type() const { return nodeFolderGroups; }
	
	// Refresh item, ald also childs objects
	void refresh() throw(const KPGSqlException &);
	
	const pqxx::result & resultGroups() const { return m_pqxxResultGroups; }
			
protected:

  	// results that will be displayed in properties window
  	pqxx::result m_pqxxResultGroups;
};

#endif
