//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGTABLESPACESFOLDER_H
#define KPGTABLESPACESFOLDER_H

#include "kpgitemsfolder.h"

class KPGServer;

/**
  * Folder that holds tablespaces list
  *
  * @author Lumir Vanek
  */
class KPGTablespacesFolder : public KPGItemsFolder
{
public:
    KPGTablespacesFolder(KPGServer *);
    ~KPGTablespacesFolder();
		
	virtual eNodeType type() const { return nodeFolderTablespaces; }
	
	// Refresh item, ald also childs objects
	void refresh() throw(const KPGSqlException &);
	
	const pqxx::result & resultTablespaces() const { return m_pqxxResultTablespaces; }
	
	bool version81_OrNewer() const { return m_bVersion81_OrNewer; }
			
protected:
  	// results that will be displayed in properties window
  	pqxx::result m_pqxxResultTablespaces; 
  
  	bool m_bVersion81_OrNewer;
};

#endif
