//
// C++ Interface: kpgusersfolder
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGUSERSFOLDER_H
#define KPGUSERSFOLDER_H

#include "kpgitemsfolder.h"

class KPGServer;

/**
  * Folder that holds database users
  *
  * @author Lumir Vanek
  */
class KPGUsersFolder : public KPGItemsFolder
{
public:
    KPGUsersFolder(KPGServer *);
    ~KPGUsersFolder();

	virtual eNodeType type() const { return nodeFolderUsers; }
	
	// Refresh item, ald also childs objects
	void refresh() throw(const KPGSqlException &);
	
	const pqxx::result & resultUsers() const { return m_pqxxResultUsers; }
				
protected:
  	// results that will be displayed in properties window
  	pqxx::result m_pqxxResultUsers;
};

#endif
