//
// C++ Interface: kpgcastproppage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCASTPROPPAGE_H
#define KPGCASTPROPPAGE_H

#include "kpgcastproppagebase.h"

// application specific includes
#include "kpgabstractpropertypage.h"

// include files for libpgxx 
#include <pqxx/util> 

class KPGCast;

/**
  * Cast properties
  *
  * @author Lumir Vanek
  */
class KPGCastPropPage : public KPGCastPropPageBase, public KPGAbstractPropertyPage
{
	Q_OBJECT
public:
    KPGCastPropPage(QWidget *parent, KPGCast *);
    ~KPGCastPropPage();

	// Return Result table for clipboard actions and export. 
	virtual QTable* tableResult() { return m_pTableProperties; }
	
	// Display properties of underlying database object
	virtual void displayProperties();
	
protected:

	KPGCast *m_pCast;
	
protected slots:
    
	virtual void slotTablePropDblClicked(int, int, int, const QPoint &);	
	                 
    // Consumes request for context menu for property table
	virtual void slotTablePropContextMenuRequested(int, int, const QPoint &);
    	
signals:
	void sigSearchObject(pqxx::oid);
	            
    // Emit request for context menu for property table
	void sigTablePropContextMenuRequested(int, int, const QPoint &);
};

#endif
