//
// C++ Implementation: kpgoperatorclassesfolderproppage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgoperatorclassesfolderproppage.h"

#include <qtable.h>

#include <klocale.h>


#include "../kpgutil.h"
#include "../DbObjects/kpgoperatorclassesfolder.h"
#include "../DbObjects/kpgconnection.h"

KPGOperatorClassesFolderPropPage::KPGOperatorClassesFolderPropPage(QWidget* parent, KPGOperatorClassesFolder * pOperatorClassesFolder)
	: KPGPropertyPage(parent, "KPGOperatorClassesFolderPropPage")
{
	m_pOperatorClassesFolder = pOperatorClassesFolder;
	displayProperties();
}


KPGOperatorClassesFolderPropPage::~KPGOperatorClassesFolderPropPage()
{
}

void KPGOperatorClassesFolderPropPage::displayProperties()
{
	QHeader* pHeader = m_pTableItems->horizontalHeader();
	
	int nCol = 0;
	pHeader->setLabel(nCol++, i18n("Name"));
  	pHeader->setLabel(nCol++, i18n("Is Default"));
	pHeader->setLabel(nCol++, i18n("Data type"));
  	pHeader->setLabel(nCol++, i18n("Key type"));
	pHeader->setLabel(nCol++, i18n("Access method"));
	pHeader->setLabel(nCol++, i18n("Owner"));

	QTextCodec * pTextCodec = m_pOperatorClassesFolder->connection()->textCodec();
	
	KPGUtil::fillPropertiesTable(m_pOperatorClassesFolder->resultOperatorClasses(), m_pTableItems, pTextCodec);
}

