//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGRESTOREDATABASEWIZARD_H
#define KPGRESTOREDATABASEWIZARD_H

#include "kpgrestoredatabasewizardbase.h"

#include <qguardedptr.h>
#include <qstrlist.h>

#include <kparts/partmanager.h>


//#include "../kpgdcoptalkthread.h"

class KonsoleViewWidget;
class DCOPClient;

/**
  * Restore database Wizard
  *
  * @author Lumir Vanek
  */
class KPGRestoreDatabaseWizard : public KPGRestoreDatabaseWizardBase
{
Q_OBJECT
public:
    KPGRestoreDatabaseWizard(QWidget *parent, const char *name, DCOPClient *, const QString &, const QString &, const QString &, const QString &, bool);
    ~KPGRestoreDatabaseWizard();

    KParts::PartManager * partManager() const { return m_pPartManager; }

protected:
    KParts::PartManager *m_pPartManager;
    DCOPClient *m_pDcopClient;
    QGuardedPtr<KonsoleViewWidget> m_pConsoleWidget;
    //KPGDcopTalkThread m_dcopTalkThread;
    
protected slots:
    virtual void slotInputFileChanged(const QString &);
    virtual void slotOnlyDataToggled(bool);
    virtual void slotOnlySchemaToggled(bool);
    
    void slotProcessExited();
    
protected:
    virtual void showPage(QWidget *);
    QStrList getRestoreArguments() const;
    
    QString m_strDatabase;
    QString m_strHostname;
    QString m_strPort;
    QString m_strUsername;
    
    bool m_bCreateFromDump;
};

#endif
