//
// C++ Interface: kpgnoticer
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGNOTICER_H
#define KPGNOTICER_H

#include <qobject.h>

// include files for libpgxx 
#include <pqxx/connection>

//class QStringList;
class QString;
class QTextCodec;

using namespace pqxx;

/**
  * Noticer is processor for error/warning messages, (coming from PostgreSQL).
  *
  *
  * @author Lumir Vanek <lvanek@users.sourceforge.net>
  */
class KPGNoticer : public QObject,  public noticer
{
	Q_OBJECT
	
public:	
	KPGNoticer(QTextCodec *);
	virtual ~KPGNoticer() throw ();
	
	virtual void operator()(const char Msg[]) throw ();
	
private:
	// Codec for encode/decode strings from/to database
	QTextCodec *m_pTextCodec;
	
signals:
	// Emit notice
    void sigNotice(const QString &);
};

#endif
