//
// C++ Interface: kpgsqlexception
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGSQLEXCEPTION_H
#define KPGSQLEXCEPTION_H

#include <stdexcept>

// include files for Qt
#include <qstring.h>

class KPGConnection;

/**
  * SQL Exception, contain info about SQL statement, that cause it
  *
  *	@author Lumir Vanek <lvanek@users.sourceforge.net>
  */
class KPGSqlException //: public std::runtime_error
{
public:
    KPGSqlException(KPGConnection *, const char *, const QString &);
    ~KPGSqlException() throw() {;}

    const QString & sql() const { return m_strSql; }
    const QString & message() const { return m_strMessage; }
    
protected:
    QString m_strMessage;
    QString m_strSql;
};

#endif
